.if !defined(PLESK_DEPENDS_MK)
PLESK_DEPENDS_MK= 1

# Create sorted list of dependencies for all depends
# and PRE_ depends.
# Delete invalid packages(witch exists into system but some 
# file from package was not found in system)
# create semaphores for right installed packages. 

# Correct depends list after deleting incorrect packages
# (cut installed packages from depends lists)
DB_FILE= ${SW_WRKDIR}/db_file

# Create local depends database
# Using: deps="<depends>"; ${SW_WRITE_DB}
SW_WRITE_DB= \
	${SW_CREATE_DB}; \
	for _deps in $$deps; do \
	    _exists=$$(awk -F '|' -v dep=$$_deps '{if (dep == $$1) {print;}}' ${DB_FILE}); \
	    if [ -n "$$_exists" ]; then \
		continue; \
	    fi; \
	    str=$$(cd ${PORTSDIR}/$$_deps && ${MAKE} ${SW_MAKEOPTS} -V PKGNAME -V PKGORIGIN | xargs echo -n); \
	    pkgname=$$(echo $$str | awk '{print $$1}'); \
	    master_origin=$$(echo $$str | awk '{print $$2}'); \
	    lib_depends=$$(cd ${PORTSDIR}/$$_deps && ${MAKE} ${SW_MAKEOPTS} -V LIB_DEPENDS | xargs echo -n); \
	    run_depends=$$(cd ${PORTSDIR}/$$_deps && ${MAKE} ${SW_MAKEOPTS} -V RUN_DEPENDS -V BUILD_DEPENDS | xargs echo -n); \
	    echo "$$_deps|$$master_origin|$$pkgname|$$lib_depends|$$run_depends|" >> ${DB_FILE}; \
	    echo -n "."; \
	done

SW_CREATE_DB= \
	[ -f "${DB_FILE}" ] || ${TOUCH} ${DB_FILE}

SW_REMOVE_DB= \
	[ -f "${DB_FILE}" ] && rm -f ${DB_FILE} || true

# Delete invalid depends
# Using: LIST="<depends>"; ${SW_DELETE_DEPENDS}
SW_DELETE_DEPENDS= \
	PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    ${PKG_DEINSTALL} -O -P -f $$LIST 1>/dev/null 2>&1 || true; \
	for _dep in $$LIST; do \
	    rm -f "${SW_WRKDIR}/.installed.$${_dep\#\#*/}"; \
	done

sw-install-depends:
	@if [ ! -z "${DEPENDS_FILE}" -a -f "${DEPENDS_FILE}" ]; then \
		echo ""; \
	    for origin in $$(cat ${DEPENDS_FILE}); do \
		echo "===> install $$origin"; \
		name="$${origin##*/}"; \
		master_origin=$$(awk -F '|' -v var=$$origin '{if (var == $$1) {printf("%s", $$2)}}' ${DB_FILE}); \
		_pkgname=$$(pkg_info -qO $$master_origin); \
		_need_install=0; \
		_need_upgrade=0; \
		if [ -z "$$_pkgname" ]; then \
		    _need_install=1; \
		else \
		    _update=$$(pkg_version -s $$_pkgname 2>/dev/null | awk '{print $$2}'); \
		    if [ "$$_update" = '<' ]; then \
			if [ "$$master_origin" != "$$origin" ]; then \
			    LIST="$$master_origin"; ${SW_DELETE_DEPENDS}; \
			    _need_install=1; \
			else \
			    _need_upgrade=1; \
			fi; \
		    else \
			if [ "$$master_origin" != "$$origin" ]; then \
			    _pkgname_self=$$(awk -F '|' -v var=$$origin '{if (var == $$1) {print $$3}}' ${DB_FILE}); \
			    if [ "$$_pkgname_self" != "$$_pkgname" ]; then \
				_need_upgrade=1; \
			    fi; \
			fi; \
		    fi; \
		fi; \
		if [ "$$_need_install" -eq 1 ]; then \
		    _pkg=$$(awk -F '|' -v var=$$origin '{if (var == $$1) {print $$3}}' ${DB_FILE}); \
		    ${PKG_ADD} ${SW_PACKAGES_DIR}/All/$${_pkg}.tbz 2>/dev/null && flag=0 || flag=1; \
		    if [ "$$flag" -ne 0 ]; then \
			    cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} install; \
			if [ -n "${CREATE_PACKAGES}" ]; then \
			    cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} package || true; \
			fi; \
		    fi; \
		    ${TOUCH} "${SW_WRKDIR}/.installed.$$name"; \
		else \
		    if [ "$$_need_upgrade" -eq 1 ]; then \
			PKGTOOLS_CONF=${PKGTOOLS_CONF} \
			    ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} -P $$origin && \
			    ${TOUCH} "${SW_WRKDIR}/.installed.$$name"; \
		    fi; \
		fi; \
	    done; \
	fi

sw-pre-depends: sw-do-mkdirs
	@echo "===> Install pre-depends for ${SELF_ORIGIN}"
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@${MAKE} ${SW_MAKEOPTS} DEPENDS="${SELF_ORIGIN}" TYPE="PRE_DEPENDS" sw-depends-req
	@cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else {print $$2; dep[x[2]] = 1; }}' \
	 > ${PRE_DEPENDS_LIST_FILE}.tmp
	@for i in $$(cat ${PRE_DEPENDS_LIST_FILE}.tmp) ${SELF_ORIGIN}; do \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
	    	_list_depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} ${SW_MAKEOPTS} -V PRE_DEPENDS); \
	    	if [ -n "$$_list_depends" ]; then \
		    echo "$$_list_depends" >> ${PRE_DEPENDS_LIST_FILE}.list; \
	    	fi; \
	    fi; \
	done
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@rm -f ${CHECKED_FILE}.list && ${TOUCH} ${CHECKED_FILE}.list
	@for _dep in $$(cat ${PRE_DEPENDS_LIST_FILE}.list 2>/dev/null); do \
	    ${MAKE} ${SW_MAKEOPTS} DEPENDS="$$_dep" sw-depends-req; \
	    cat ${CHECKED_FILE} >> ${CHECKED_FILE}.list; \
	    echo "1 $$_dep" >> ${CHECKED_FILE}.list; \
	done
	@cat ${CHECKED_FILE}.list | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else {print $$2; dep[x[2]] = 1; }}' \
	 > ${PRE_DEPENDS_LIST_FILE}.tmp
	@deps="$$(cat ${PRE_DEPENDS_LIST_FILE}.tmp | xargs echo -n) $$_dep"; ${SW_WRITE_DB}
	@${MAKE} ${SW_MAKEOPTS} sw-drop-invalid-depends DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}.tmp"
	@rm -f ${PRE_DEPENDS_LIST_FILE} && ${TOUCH} ${PRE_DEPENDS_LIST_FILE}
	@for i in $$(cat ${PRE_DEPENDS_LIST_FILE}.tmp); do \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
	    	echo "$$i" >> ${PRE_DEPENDS_LIST_FILE}; \
	    fi; \
	done
	@echo ""
	@${MAKE} ${SW_MAKEOPTS} DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}" sw-fetch-depends sw-install-depends
	@${SW_REMOVE_DB}; ${SW_CREATE_DB}

.if !exists(${DEPENDS_LIST_FILE})
sw-depends-list: sw-do-mkdirs
	@echo "===> Create list of depends for: ${PKGNAME}"
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@${MAKE} ${SW_MAKEOPTS} DEPENDS="${SELF_ORIGIN}" sw-depends-req
	@cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else {print $$2; dep[x[2]] = 1; }}' \
	 > ${DEPENDS_LIST_FILE}.tmp
	@deps="$$(cat ${DEPENDS_LIST_FILE}.tmp | xargs echo -n) ${SELF_ORIGIN}"; ${SW_WRITE_DB}
	@${MAKE} ${SW_MAKEOPTS} sw-drop-invalid-depends DEPENDS_FILE="${DEPENDS_LIST_FILE}.tmp"
	@echo "" > ${DEPENDS_LIST_FILE}
	@for _dep in $$(cat ${DEPENDS_LIST_FILE}.tmp); do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		echo "$$_dep" >> ${DEPENDS_LIST_FILE}; \
	    fi; \
	done
.else
sw-depends-list:
.endif # DEPENDS_LIST_FILE

sw-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    _exists=$$(awk -F '|' -v dep=$$i '{if (dep == $$1) {print;}}' ${DB_FILE}); \
	    if [ -z "$$_exists" ]; then \
		deps="$$i"; ${SW_WRITE_DB}; \
	    fi; \
	    if [ "$${i%/*}" != "${SW_CATEGORY}" -a "${TYPE}" = "PRE_DEPENDS" ]; then \
		continue; \
	    fi; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$${i##*/}" ]; then \
		    _list_depends=$$(awk -F '|' -v origin="$$i" '{if ($$1 == origin) {printf("%s %s ", $$4, $$5)}}' ${DB_FILE}); \
		    src_depends=''; \
		    for _dep in $$_list_depends; do \
			    src_depends="$$src_depends $${_dep##*:}"; \
		    done; \
		    src_depends=$$(echo "$$src_depends" | sed -e 's|${PORTSDIR}/||g' ); \
		    depends=''; \
		    for dep in $$src_depends; do \
			sw_checked=$$(awk -v var1="$$__MKLVL__" -v var2="$$dep" '{ \
				if (($$1 >= var1) && ($$2 == var2)) {print var1} \
			    }' ${CHECKED_FILE}); \
			if [ -z "$$sw_checked" ]; then \
			    echo "$$__MKLVL__ $$dep" >> ${CHECKED_FILE}; \
			    depends="$$depends $$dep"; \
			fi; \
		    done ; \
		    if [ -n "$$depends" ]; then \
			${MAKE} ${SW_MAKEOPTS} DEPENDS="$$depends" sw-depends-req; \
		    fi; \
	    fi; \
	    echo -n '.'; \
	done

sw-drop-invalid-depends:
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@checklist=''; \
	for _dep in $$(cat ${DEPENDS_FILE}) ${SELF_ORIGIN}; do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		for i in $$(awk -F '|' -v var=$$_dep '{if (var == $$1) {print $$4}}' ${DB_FILE}); do \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ -z "$$sw_checked" ]; then \
			name="$${i##*/}"; \
		        origin=$$(echo "$${i##*:}" | sed -e 's|${PORTSDIR}/||g'); \
			master_origin=$$(awk -F '|' -v var=$$origin '{if (var == $$1) {printf("%s ", $$2)}}' ${DB_FILE}); \
			_var=$$(pkg_info -qO $$master_origin); \
			if [ -z "$$_var" ]; then \
			    installed=''; \
			else \
			    installed=$$(pkg_version -s $$_var 2>/dev/null | awk '{print $$2}'); \
			fi; \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    lib=$${i%%:*}; \
			    case $$lib in \
				*.*.*)  pattern="`${ECHO_CMD} $$lib | ${SED} -e 's/\./\\\\./g'`" ;;\
				*.*)    pattern="$${lib%%.*}\.$${lib#*.}" ;;\
				*)  pattern="$$lib" ;;\
			    esac; \
			    if ${LDCONFIG} -r | ${GREP} -vwF -e "${PKGCOMPATDIR}" | ${GREP} -qwE -e "-l$$pattern"; then \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    else \
				checklist="$$checklist $$master_origin"; \
			    fi; \
			else \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		    echo -n '.'; \
		done; \
		for i in $$(awk -F '|' -v var=$$_dep '{if (var == $$1) {print $$5}}' ${DB_FILE}); do \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ -z "$$sw_checked" ]; then \
			name="$${i##*/}"; \
		        origin=$$(echo "$${i##*:}" | sed -e 's|${PORTSDIR}/||g'); \
			master_origin=$$(awk -F '|' -v var=$$origin '{if (var == $$1) {printf("%s ", $$2)}}' ${DB_FILE}); \
			_var=$$(pkg_info -qO $$master_origin); \
			if [ -z "$$_var" ]; then \
			    installed=''; \
			else \
			    installed=$$(pkg_version -s $$_var 2>/dev/null | awk '{print $$2}'); \
			fi; \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    prog=$${i%%:*}; \
			    if ${EXPR} "$$prog" : \\/ >/dev/null; then \
				if [ -e "$$prog" ]; then \
				    found=1; \
				else \
				    found=0; \
				fi; \
			    else \
				prog=$$(echo $$prog | sed -e 's/[<|>|=].*//g'); \
				if ${WHICH} "$$prog" > /dev/null 2>&1 ; then \
				    found=1; \
				else \
				    found=0; \
				fi; \
			    fi; \
			    if [ $$found = 0 ]; then \
				checklist="$$checklist $$master_origin"; \
			    else \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    fi; \
			else \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		    echo -n '.'; \
		done; \
	    fi; \
	done; \
	${SW_CONFLICTS}; \
	if [ -n "$$checklist" ]; then \
	    LIST="$$checklist"; ${SW_DELETE_DEPENDS}; \
	fi

.endif # PLESK_DEPENDS_MK

