.if !defined(PLESK_TARGETS_MK)
PLESK_TARGETS_MK= 1

# --------------------------------------------------------------------
.if defined(IGNORE)
.if defined(IGNORE_SILENT)
IGNORECMD=      ${DO_NADA}
.else
IGNORECMD=      ${ECHO_MSG} "===>  ${PKGNAME} "${IGNORE:Q}.;exit 1
.endif
.endif

# --------------------------------------------------------------------
pre-fetch: 
	@${MKDIR} ${.CURDIR}/work

#-----------------------------------------------------------------------------------------
pre-extract: do-index

. if ${OSVERSION} > 610000
do-extract:
	@${RM} -rf ${WRKDIR}
	@${MKDIR} ${WRKSRC}
. else
.    if !target(do-extract) && defined(NO_EXTRACT)
	@${MKDIR} ${WRKSRC}
.    endif
. endif

#Configure 
#-----------------------------------------------------------------------------------------
.if defined(NO_CONFIGURE)
configure: extract
.endif

#Build targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_BUILD)

.if !target(build)
build: configure pre-build 
	@${TOUCH} ${TOUCH_FLAGS} ${BUILD_COOKIE}
.endif

.if !target(do-build)
do-build:
.endif

.endif #NO_BUILD

#Install targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_INSTALL)

pre-install:

.if !target(do-install)
do-install: do-install-pre do-install-now do-exec do-install-post
 
do-install-pre:
. if !defined(NO_SCRIPTS) && !defined(SYSTEM_INSTALL)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} PRE-INSTALL
. endif

.if !target(do-install-now)
do-install-now:
. if !defined(NO_EXTRACT) && !defined(NO_INSTALL)
	@echo -n "---> Copying files into installation directory... "
.    if ${OSVERSION} >= 601000
	@for file in ${EXTRACT_ONLY}; do \
		if ! (${EXTRACT_CMD} ${EXTRACT_BEFORE_ARGS} ${_DISTDIR}/$$file ${EXTRACT_AFTER_ARGS} -C ${PACKAGE_INSTALLDIR} --strip-components 1); \
		then \
		    exit 1; \
		fi; \
	done
.    else
	@${CP} -RPf ${WRKSRC}/* ${PACKAGE_INSTALLDIR}/
.    endif
	@echo "done"
. endif
.endif

do-install-post:
. if !defined(NO_SCRIPTS) && !defined(SYSTEM_INSTALL)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL
. endif
.endif

.endif

#-------------------------------------------------------------------------------------------
# Set correct permissions 
#-------------------------------------------------------------------------------------------
EXEC_LIST!= [ -f ${.CURDIR}/pkg-plist ] && cat ${.CURDIR}/pkg-plist | grep '@exec ' | sed ${SED_ENV} || true

.if !target(do-exec)
do-exec:
	@for CMD in ${EXEC_LIST}; do \
		${SH} -c "$$CMD" || true; \
	done
.endif

.endif # PLESK_TARGETS_MK
